<?php
$install_directory = "/UltimateTagWarrior";
$starttag = "[tag]";
$endtag = "[/tag]";

$starttags = "[tags]";
$endtags = "[/tags]";

$embedtags = get_option('utw_use_embedded_tags');

$embeddedtagformat = array('first'=>'%taglink%', 'default'=>', %taglink%');

class UltimateTagWarriorActions {

	/* ultimate_admin_menus
	Adds a tag management page to the menu.
	*/
	function ultimate_admin_menus() {
		// Add a new menu under Manage:
		add_management_page('标签管理', '标签', 8, basename(__FILE__), array('UltimateTagWarriorActions', 'ultimate_better_admin'));

		// And one under options
		add_options_page('标签选项', '标签', 8, basename(__FILE__), array('UltimateTagWarriorActions', 'utw_options'));
	}

/* ultimate_rewrite_rules

*/
function ultimate_rewrite_rules($rules) {
	if(get_option("utw_use_pretty_urls") == "yes") {
		$baseurl = get_option("utw_base_url");

		global $wp_rewrite;

		$wp_rewrite->add_rewrite_tag('%tag%', '(.*)', 'tag=');

		// without trailing slash
		$rules = $wp_rewrite->generate_rewrite_rules($baseurl . '%tag%') + $rules;
		// with trailing slash
		$rules = $wp_rewrite->generate_rewrite_rules($baseurl . '%tag%/') + $rules;
	}
	return $rules;
}

function utw_options() {
	global $lzndomain, $utw, $wpdb, $tabletags, $tablepost2tag, $install_directory;

	$siteurl = get_option('siteurl');

	$autoincludedhelp = '这些设置允许本插件自动在文章中显示标签而无需修改模版。您可以选择标签是显示在文章的前面还是后面，并可以显示至多两组标签。“基本格式”设置标签的基本样式，前缀和后缀可以让您在标签的前后添加一些 HTML 或者“标签”文本或者图标，或者将标签包裹在 &lt;ul&gt; 中。';

	echo '<div class="wrap">';

	$configValues = array();

	$configValues[] = array("setting"=>"", "label"=>"网址设置",  "type"=>"label");
	$configValues[] = array("setting"=>"", "value"=>"这些设置控制了标签的外观。您可以将“基本网址”更改为任何您想要的，但是它应该以斜杠开始和结束。默认的，标签页面的网址为 /tag/标签名。如果您想更改标签网址为 /tag/标签名/ (注意尾部的斜杠)，那么请选中“尾部斜杠”复选框。",  "type"=>"help");
	$configValues[] = array("setting"=>"utw_use_pretty_urls", "label"=>"为本地标签网址使用 URL Rewriting (用 /tag/tag 替代 index.php?tag=tag)",  "type"=>"boolean");
	$configValues[] = array("setting"=>"utw_base_url", "label"=>"基本网址",  "type"=>"string");
	$configValues[] = array("setting"=>"utw_trailing_slash", 'label'=>"在标签网址中包含尾部的斜杠", 'type'=>'boolean');

	$configValues[] = array("setting"=>"", "label"=>"Meta 关键词",  "type"=>"label");
	$configValues[] = array("setting"=>"", "value"=>"启用后，Meta 关键词会包含在标签页面以及文章页面的 header 中。这些关键词有些时候会被搜索引擎索引。",  "type"=>"help");
	$configValues[] = array("setting"=>"utw_show_meta_keywords", 'label'=>"包括 Meta 关键词", 'type'=>'boolean');

	$configValues[] = array("setting"=>"", "label"=>"嵌入标签",  "type"=>"label");
	$configValues[] = array("setting"=>"", "value"=>"嵌入标签是嵌入到文章内容中的标签。它使用 <a href=\"http://www.broobles.com/scripts/simpletags/\">Simple Tags</a> 插件的格式，这是最好的选择。文章内容中如果有 [tag]标签[/tag]，会被转换成本地标签的链接，并会被添加到文章标签的列表中；[tags]标签1, 标签2[/tags] 会被认为是两个标签，逗号分隔，并添加到到文章标签的列表中，并且在您查看文章的时候不会显示出来。",  "type"=>"help");
	$configValues[] = array("setting"=>"utw_use_embedded_tags", "label"=>"使用嵌入标签",  "type"=>"boolean");

	$configValues[] = array("setting"=>"", "label"=>"调试",  "type"=>"label");

	$configValues[] = array("setting"=>"", "value"=>"启用这个选项将在 HTML 注释中显示一些调试信息。正常情况下您无需启用它 (:",  "type"=>"help");
	$configValues[] = array("setting"=>"utw_debug", 'label'=>"输出调试信息", 'type'=>'boolean');

	$configValues[] = array("setting"=>"", "label"=>"自动聚合标签",  "type"=>"label");

	$configValues[] = array("setting"=>"", "value"=>"启用这个选项后，您的文章聚合中将会包含到标签的链接", "type"=>"help");
	$configValues[] = array("setting"=>"utw_append_tag_links_to_feed", 'label'=>"聚合中包括本地标签链接", 'type'=>'boolean');

	$configValues[] = array("setting"=>"", "label"=>"主内容标签",  "type"=>"label");
	$configValues[] = array("setting"=>"", "value"=>$autoincludedhelp, "type"=>"help");
	$configValues[] = array("setting"=>"utw_include_local_links", "label"=>"自动显示主标签链接", "type"=>"dropdown", options=>array('不显示', '在文章内容之前','在文章内容之后'));
	$configValues[] = array("setting"=>'utw_primary_automagically_included_link_format', 'label'=>'主标签链接基本格式', 'type'=>'dropdown', 'options'=>$utw->GetPredefinedFormatNames());
	$configValues[] = array("setting"=>'utw_primary_automagically_included_prefix', 'label'=>'主标签链接前缀 (选填)', 'type'=>'string');
	$configValues[] = array("setting"=>'utw_primary_automagically_included_suffix', 'label'=>'主标签链接后缀 (选填)', 'type'=>'string');

	$configValues[] = array("setting"=>"", "label"=>"副内容标签",  "type"=>"label");
	$configValues[] = array("setting"=>"", "value"=>$autoincludedhelp,  "type"=>"help");
	$configValues[] = array("setting"=>"utw_include_technorati_links", "label"=>"自动显示副标签链接",   "type"=>"dropdown", options=>array('不显示', '在文章内容之前','在文章内容之后'));
	$configValues[] = array("setting"=>'utw_secondary_automagically_included_link_format', 'label'=>'副标签链接基本格式', 'type'=>'dropdown', 'options'=>$utw->GetPredefinedFormatNames());
	$configValues[] = array("setting"=>'utw_secondary_automagically_included_prefix', 'label'=>'副标签链接前缀 (选填)', 'type'=>'string');
	$configValues[] = array("setting"=>'utw_secondary_automagically_included_suffix', 'label'=>'副标签链接后缀 (选填)', 'type'=>'string');

	$configValues[] = array("setting"=>"", "label"=>"全局格式设置",  "type"=>"label");

	$configValues[] = array("setting"=>"", "value"=>"颜色用十六进制表示，并且需要完整的六位 (#eee 是 #eeeeee 的简写)。两个文字大小选项设置了最大和最小的标签文字。文章大小单位选项决定了两个文字大小选项所使用的单位。如果您在上面的“基本格式”中选择了包含图标的格式，那么下面打勾的图标将会全部显示出来。",  "type"=>"help");
	$configValues[] = array("setting"=>"utw_tag_cloud_max_color", "label"=>"人气最旺标签颜色",  "type"=>"color");
	$configValues[] = array("setting"=>"utw_tag_cloud_max_font", "label"=>"人气最旺标签文字大小",  "type"=>"color");
	$configValues[] = array("setting"=>"utw_tag_cloud_min_color", "label"=>"人气最差标签颜色",  "type"=>"color");
	$configValues[] = array("setting"=>"utw_tag_cloud_min_font", "label"=>"人气最差标签文字大小",  "type"=>"color");
	$configValues[] = array("setting"=>'utw_tag_cloud_font_units', 'label'=>'文字大小单位', "type"=>"dropdown", "options"=>array('%','pt','px','em'));

	$configValues[] = array("setting"=>'utw_icons', 'label'=>'在图标格式中显示的图标', "type"=>"multiselect", "options"=>array('Technorati','Flickr','delicious','Wikipedia','gadabe', 'Zniff', 'RSS'));

	$configValues[] = array('setting'=>'utw_no_tag_text', 'label'=>'在没有标签时显示的文本 (可以留空)', 'type'=>'string');

	$configValues[] = array("setting"=>"", "label"=>"编辑选项",  "type"=>"label");
	$configValues[] = array("setting"=>"", "value"=>"这些选项是有关编辑标签的选项。“显示存在的标签”选项启用后，将在文章编辑页面显示您的 Blog 已经存在的标签，方便您添加。“下拉框”选项将显示一个按字母顺序的下拉框，“标签列表”选项将显示一个简单的标签列表。“自动将分类添加为标签”选项把分类自动作为标签添加到标签列表中。",  "type"=>"help");

	$configValues[] = array("setting"=>"utw_always_show_links_on_edit_screen", "label"=>"在文章编辑页面显示存在的标签",  "type"=>"dropdown", "options"=>array('不显示', '下拉框', '标签列表'));
	$configValues[] = array("setting"=>"utw_include_categories_as_tags", "label"=>"自动将分类添加为标签",  "type"=>"boolean");



	if ($_POST["action"] == "saveconfiguration") {
		foreach($configValues as $setting) {
			if ($setting['type'] == 'multiselect') {
				$options = '|';

				foreach($setting['options'] as $option) {
					$options .= $_POST[$setting['setting'] . ":" . $option] . '|';
				}
				update_option($setting['setting'], $options);
			} else if ($setting['type'] != 'label') {
				update_option($setting['setting'], $_POST[$setting['setting']]);
			}
		}
		echo "<div class=\"updated\"><p>设置已更新</p></div>";
	}

	echo "<fieldset class=\"options\"><legend>" . "帮助!" . "</legend><a href=\"$siteurl/wp-content/plugins$install_directory/ultimate-tag-warrior-help.html\" target=\"_new\">" . "本地帮助" . "</a> | <a href=\"http://www.neato.co.nz/ultimate-tag-warrior\" target=\"_new\">" . "作者帮助" . "</a> | <a href=\"./edit.php?page=ultimate-tag-warrior-actions.php\">管理标签</a></fieldset>";
	echo '<fieldset class="options"><legend>' . '配置' . '</legend>';
	echo "<form method=\"POST\">";
	echo '<table width="100%" cellpadding="3" cellspacing="0">';

	foreach($configValues as $setting) {
		if ($setting['type'] == 'boolean') {
			UltimateTagWarriorActions::show_toggle($setting['setting'], $setting['label'], get_option($setting['setting']));
		}

		if ($setting['type'] == 'string') {
			UltimateTagWarriorActions::show_string($setting['setting'], $setting['label'], get_option($setting['setting']));
		}

		if ($setting['type'] == 'color') {
			UltimateTagWarriorActions::show_color($setting['setting'], $setting['label'], get_option($setting['setting']));
		}

		if ($setting['type'] == 'label') {
			UltimateTagWarriorActions::show_label($setting['setting'], $setting['label'], get_option($setting['setting']));
		}
		if ($setting['type'] == 'dropdown') {
			UltimateTagWarriorActions::show_dropdown($setting['setting'], $setting['label'], get_option($setting['setting']), $setting['options']);
		}

		if ($setting['type'] == 'multiselect') {
			UltimateTagWarriorActions::show_multiselect($setting['setting'], $setting['label'], get_option($setting['setting']), $setting['options']);
		}
		if ($setting['type'] == 'help') {
			UltimateTagWarriorActions::show_help($setting['setting'], $setting['label'], $setting['value']);
		}
	}
echo <<<CONFIGFOOTER
	</table>
			<input type="hidden" name="action" value="saveconfiguration">
			<input type="hidden" name="page" value="ultimate-tag-warrior-actions.php">
			<input type="submit" value="保存">
		</form>
	</fieldset>
CONFIGFOOTER;
}

function ultimate_better_admin() {
	global $lzndomain, $utw, $wpdb, $tabletags, $tablepost2tag, $install_directory;

	$siteurl = get_option('siteurl');

	echo '<div class="wrap">';

	if ($_GET["action"] == "savetagupdate") {
		$tagid = $_GET["edittag"];

		if ($_GET["updateaction"] == "重命名") {
			if (!is_numeric($tagid)) {
				echo "<div class=\"error\"><p>传递了一个无效的标签 ID。</p></div>";
				return;
			}


			$tag = $_GET["renametagvalue"];

			$tagset = explode(",", $tag);

			$q = "SELECT post_id FROM $tablepost2tag WHERE tag_id = $tagid";
			$postids = $wpdb->get_results($q);

			$tagids = array();

			foreach ($tagset as $tag) {
				$tag = trim($tag);
				$tag = str_replace(' ', '-', $tag);
				$tag = str_replace('"', '', $tag);
				$tag = str_replace("'", '', $tag);

				$q = "SELECT tag_id FROM $tabletags WHERE tag = '$tag'";
				$thistagid = $wpdb->get_var($q);

				if (is_null($thistagid)) {
					$q = "INSERT INTO $tabletags (tag) VALUES ('$tag')";
					$wpdb->query($q);
					$thistagid = $wpdb->insert_id;
				}
				$tagids[] = $thistagid;
			}

			$keepold = false;
			foreach($tagids as $newtagid) {
				if ($postids ) {
					foreach ($postids as $postid) {
						if ($wpdb->get_var("SELECT COUNT(*) FROM $tablepost2tag WHERE tag_id = $newtagid AND post_id = $postid->post_id") == 0) {
							$wpdb->query("INSERT INTO $tablepost2tag (tag_id, post_id) VALUES ($newtagid, $postid->post_id)");
						}
					}
				} else {
					// I guess we were renaming something which wasn't being used...
				}

				if ($newtagid == $tagid) {
					$keepold = true;
				}
			}

			if (!$keepold) {
				$q = "delete from $tablepost2tag where tag_id = $tagid";
				$wpdb->query($q);

				$q = "delete from $tabletags where tag_id = $tagid";
				$wpdb->query($q);
			}
			$utw->ClearAllTagPostMeta();
			echo "<div class=\"updated\"><p>标签已更新。</p></div>";
		}

		if ($_GET["updateaction"] == "保存同义词") {
			$synonyms = $_GET["synonyms"];
			$synonyms = explode(',', $synonyms);
			$utw->ClearSynonymsForTag($_GET["synonymtag"]);
			$message = "";
			foreach($synonyms as $synonym) {
				$message .= $utw->AddSynonymForTag("", $_GET["synonymtag"], $synonym);
				$message .= $synonym . " ";
			}

			echo "<div class=\"updated\"><p>已添加 $message 。</p></div>";
		}

		if ($_GET["updateaction"] =="删除标签") {
			if (!is_numeric($tagid)) {
				echo "<div class=\"error\"><p>传递了一个无效的标签 ID。</p></div>";
				return;
			}

			$q = "delete from $tablepost2tag where tag_id = $tagid";
			$wpdb->query($q);

			$q = "delete from $tabletags where tag_id = $tagid";
			$wpdb->query($q);
			$utw->ClearAllTagPostMeta();
			echo "<div class=\"updated\"><p>标签已删除。</p></div>";
		}
		if ($_GET["updateaction"] == "强制重新安装") {
			$message = $utw->ForceInstall();
			if ($message) {
				echo "<div class=\"updated\"><p>$message</p></div>";
			} else {
				echo "<div class=\"updated\"><p>重新安装已完成。</p></div>";
			}
		}
		if ($_GET["updateaction"] == "整理标签") {
			$utw->TidyTags();
			echo "<div class=\"updated\"><p>标签已整理。</p></div>";
		}
		if ($_GET["updateaction"] == "导入嵌入标签") {
			$postids = $wpdb->get_results("SELECT id FROM $wpdb->posts");
			foreach ($postids as $postid) {
				$utw->SaveEmbeddedTags($postid->id);
			}

			echo "<div class=\"updated\"><p>嵌入标签已成功导入。</p></div>";
		}
		if ($_GET["updateaction"] == "转换分类到标签") {
			$postids = $wpdb->get_results("SELECT id FROM $wpdb->posts");
			foreach ($postids as $postid) {
				$utw->SaveCategoriesAsTags($postid->id);
			}

			echo "<div class=\"updated\"><p>分类已成功转换为标签。</p></div>";
		}
		if ($_GET["updateaction"] == "从自定义栏目中导入") {
			update_option('utw_custom_field_conversion_field_name', $_GET["fieldName"]);
			update_option('utw_custom_field_conversion_delimiter', $_GET["delimiter"]);

			if ($_GET['fieldName'] && $_GET['delimiter']) {
				$postids = $wpdb->get_results("SELECT id FROM $wpdb->posts");
				foreach ($postids as $postid) {
					$utw->SaveCustomFieldAsTags($postid->id, $_GET["fieldName"], $_GET["delimiter"]);
				}
				echo "<div class=\"updated\"><p>标签已从一个自定义栏目中导入。</p></div>";
			} else {
				echo "<div class=\"updated\"><p>无法从自定义栏目中导入标签。</p></div>";
			}
		}
		if ($_GET["updateaction"] == "导出到自定义栏目") {
			update_option('utw_custom_field_conversion_field_name', $_GET["fieldName"]);
			update_option('utw_custom_field_conversion_delimiter', $_GET["delimiter"]);

			if ($_GET['fieldName'] && $_GET['delimiter']) {
				$postids = $wpdb->get_results("SELECT id FROM $wpdb->posts");
				foreach ($postids as $postid) {
					$utw->SaveTagsAsCustomField($postid->id, $_GET["fieldName"], $_GET["delimiter"]);
				}
				echo "<div class=\"updated\"><p>标签已导出到一个自定义栏目。</p></div>";
			} else {
				echo "<div class=\"updated\"><p>无法导出标签到自定义栏目。</p></div>";
			}
		}
	}

	echo "<fieldset class=\"options\"><legend>" . "帮助!" . "</legend><a href=\"$siteurl/wp-content/plugins$install_directory/ultimate-tag-warrior-help.html\" target=\"_new\">" . "本地帮助" . "</a> | <a href=\"http://www.neato.co.nz/ultimate-tag-warrior\" target=\"_new\">" . "作者帮助" . "</a> | <a href=\"./options-general.php?page=ultimate-tag-warrior-actions.php\">配置</a></fieldset>";

	echo '<fieldset class="options"><legend>' . "编辑标签" .'</legend>';
	echo '<p>' . "输入一个逗号分隔的标签列表，以将一个标签分割为多个。" . '</p>';
OPTIONS;
	$tags = $utw->GetPopularTags(-1, 'asc', 'tag');
	if ($tags) {
		echo "<form action=\"$siteurl/wp-admin/edit.php\">";

		echo "<select name=\"edittag\">";
		foreach($tags as $tag) {
			echo "<option value=\"$tag->tag_id\">$tag->tag</option>";
		}

		echo '</select> <input type="text" name="renametagvalue"> <input type="submit" name="updateaction" value="' . "重命名" . '"> <input type="submit" name="updateaction" value="' . "删除标签" . '" OnClick="javascript:return(confirm(\'' . "您确认要删除这个标签吗?" . '\'))">';
		echo '<input type="hidden" name="action" value="savetagupdate">';
		echo '<input type="hidden" name="page" value="ultimate-tag-warrior-actions.php">';
		echo '</form>';
	} else {
		echo '<p>' . '当前没有使用中的标签。' . '</p>';
	}
	echo "</fieldset>";

	echo '<fieldset class="options"><legend>' . "指定同义词" .'</legend>';
	echo '<p>' . "输入逗号分隔的同义词的列表。同义词顾名思义，是某个标签的别名。同义词标签会链接到正式标签的页面。" . '</p>';
	$tags = $utw->GetPopularTags(-1, 'asc', 'tag');
	if ($tags) {
		echo "<form action=\"$siteurl/wp-admin/edit.php\">";
		echo "<select name=\"synonymtag\" onChange=\"sndReqGenResp('editsynonyms', this.value, '', '')\">";
		foreach($tags as $tag) {
			echo "<option value=\"$tag->tag_id\">$tag->tag</option>";
		}

		echo '</select> <span id="ajaxResponse"><input type="text" name="synonyms" value="' . $utw->FormatTags($utw->GetSynonymsForTag($tags[0]->tag,''), array("first"=>"%tag%", "default"=>", %tag%")) . '" /></span> <input type="submit" name="updateaction" value="' . "保存同义词" . '">';
		echo '<input type="hidden" name="action" value="savetagupdate">';
		echo '<input type="hidden" name="page" value="ultimate-tag-warrior-actions.php">';
		echo '</form>';
	} else {
		echo '<p>' .'当前没有使用中的标签。' . '</p>';
	}
	echo "</fieldset>";


	echo "<form action=\"$siteurl/wp-admin/edit.php\">";

	echo '<fieldset class="options"><legend>' . '强制重新安装' . '</legend>';
	_e('<p>强制重新安装将重新运行安装程序。它<strong>不会</strong>删除标签数据表。</p>');
	echo '<input type="submit" name="updateaction" value="' . '强制重新安装' . '"></fieldset>';

	echo '<fieldset class="options"><legend>' . '整理标签' . '</legend>';
	_e('<p>整理标签是一件比较危险的事情。<strong>请务必在点击这个按钮之前备份您的数据库。</strong></p><p>整理标签将移除任何被删除的标签到任何被删除的文章之间的关联；删除任何没有关联文章的标签；将同名标签合并到单一标签中。</p>');
	echo '<input type="submit" name="updateaction" value="' . '整理标签' . '" OnClick="javascript:return(confirm(\'' . "您确认要清理标签?" . '\'))"></fieldset>';

	echo '<fieldset class="options"><legend>' . '将分类转换为标签' . '</legend>';
	_e('<p>再次提醒.. 非常危险.. 务必先备份您的数据库!</p>');
	echo '<input type="submit" name="updateaction" onClick="javascript:return(confirm(\'' . '您确认要将分类转换为标签?' . '\'))" value="' . '转换分类到标签' . '"></fieldset>';

	echo '<fieldset class="options"><legend>' . "导入嵌入标签" . '</legend>';
	_e('<p>也是非常危险.. 务必先备份您的数据库!</p>');
	echo '<input type="submit" name="updateaction" onClick="javascript:return(confirm(\'' . '您确认要导入嵌入标签?' . '\'))" value="' . "导入嵌入标签" . '"></fieldset>';

	echo '<fieldset class="options"><legend>' . '自定义栏目' . '</legend>';
	_e('<p>下面两个栏目允许您将标签信息从自定义栏目移动到标签结构中，或者移动标签结构到自定义栏目中。</p><p>在从自定义栏目移动信息到标签结构时，存在的标签会被保留。但是，复制标签到自定义栏目<strong>将覆盖所有存在的值</strong>。要保留存在的值，在导出前请先进行导入操作。</p><p><strong>这个功能应该能够正常工作，不过您最好还是首先备份您的数据库，以防万一。</strong></p>', $lzndomain);
	echo '<table><tr><td>' . "自定义栏目名称" . '</td><td><input type="text" name="fieldName" value="' . $fieldName . '" /></td></tr>';
	echo '<tr><td>' . "标签分隔符" . '</td><td><input type="text" name="delimiter" value="' . $delimiter . '" /></td></tr></table>';
	echo '<input type="submit" name="updateaction" value="' . "从自定义栏目中导入" . '" />';
	echo '<input type="submit" name="updateaction" value="' . "导出到自定义栏目" . '" OnClick="javascript:return(confirm(\'' . '注意: 这将覆盖自定义栏目中的所有数据。是否继续?' . '\'))"/></fieldset>';

	echo '<input type="hidden" name="action" value="savetagupdate">';
	echo '<input type="hidden" name="page" value="ultimate-tag-warrior-actions.php">';
	echo '</form>';
}

function show_dropdown($settingName, $label, $value, $options) {
	echo "<tr><td>$label</td><td><select name=\"$settingName\">";

	foreach($options as $option) {
		echo "<option value=\"$option\"";
		if ($value == $option) {
			echo " selected";
		}
		echo ">$option</option>";
	}

	echo "</select></td></tr>";
}

function show_multiselect($settingName, $label, $value, $options) {
	echo "<tr><td valign=\"top\">$label</td><td>";

	foreach($options as $option) {
		echo "<input type='checkbox' value=\"$option\" name=\"$settingName:$option\"";
		if (strpos($value,$option) > 0) {
			echo " checked";
		}
		echo "> $option<br />";
	}

	echo "</td></tr>";
}

function show_help($settingName, $label, $value) {
	echo <<<FORMWIDGET
<tr><td colspan="2" bgcolor="#f6f6f6">$value</td></tr>
FORMWIDGET;
}

function show_label($settingName, $label, $value) {
	echo <<<FORMWIDGET
<tr><td colspan="2" bgcolor="#DDD"><strong>$label</strong></td></tr>
FORMWIDGET;
}

function show_color($settingName, $label, $value) {
	echo <<<FORMWIDGET
<tr><td>$label</td><td><input type="text" name="$settingName" value="$value" maxlength="7" size="9"></td></tr>
FORMWIDGET;
}

function show_string($settingName, $label, $value) {
	echo <<<FORMWIDGET
<tr><td>$label</td><td><input type="text" name="$settingName" value="$value"></td></tr>
FORMWIDGET;
}

function show_toggle($settingName, $label, $value) {
	if ($value == 'yes') {
		$yeschecked = " checked";
	}
	echo <<<FORMWIDGET
<tr><td>$label</td><td><input type="checkbox" name="$settingName" id="$settingName" value="yes" $yeschecked></td></tr>
FORMWIDGET;
}

/*
ultimate_tag_templates
Handles the inclusion of templates, when appropriate.

index.php?archive=tag (or equivalent) will try and use the template tag_all.php
index.php?tag={tag name} (or equivalent) will try and use the template tag.php
*/
function ultimate_tag_templates() {
	if ($_GET["archive"] == "tag") {
		include(TEMPLATEPATH . '/tag_all.php');
		exit;
	} else 	if (get_query_var("tag") != "") {
		ultimate_get_posts();

		if (is_feed()) {

			return;
		}
		if (file_exists(TEMPLATEPATH . "/tag.php")) {
			if ( $_GET["feed"] == '') {
				include(TEMPLATEPATH . '/tag.php');
				exit;
			}
		} else {
	//		include(TEMPLATEPATH . '/index.php');
		}
	}
}

/*
ultimate_save_tags
Saves the tags for the current post to the database.

$postID the ID of the current post
$_POST['tagset'] the list of tags.
*/
function ultimate_save_tags($postID)
{
	global $wpdb, $table_prefix, $utw, $starttag, $endtag, $starttags, $endtags, $embedtags, $utw;

	$tags = $wpdb->escape($_POST['tagset']);
	$tags = explode(',',$tags);

	$utw->SaveTags($postID, $tags);

	if (get_option('utw_include_categories_as_tags') == "yes") {
		$utw->SaveCategoriesAsTags($postID);
		$utw->ClearTagPostMeta($postID);
	}

	if ($embedtags == 'yes') {
		$post = &get_post($postID);

		$tags = $utw->ParseEmbeddedTags($post->post_content);

		if ($tags) {
			foreach($tags as $tag) {
				$utw->AddTag($postID, $tag);
			}
		}
	}

    return $postID;
}

function ultimate_delete_post($postID) {
	global $utw;

	$utw->DeletePostTags($postID);

	return $postID;
}

/*
ultimate_display_tag_widget
Displays the tag box on the content editing page.
*/
function ultimate_display_tag_widget() {
  global $post, $wpdb, $table_prefix, $utw;

  $tabletags = $table_prefix . "tags";
  $tablepost2tag = $table_prefix . "post2tag";

  $taglist = "";


  if ( (is_object($post) && $post->ID) || (!is_object($post) && $post)) {
	if (is_object($post)) {
		$postid = $post->ID;
	} else {
		$postid = $post;
	}

	if (is_numeric($postid)) {
		$q = "select t.tag from $tabletags t inner join $tablepost2tag p2t on t.tag_id = p2t.tag_id and p2t.post_id=$postid";
		$tags = $wpdb->get_results($q);
	}

    if ($tags) {
	  foreach($tags as $tag) {
		  $taglist .= $tag->tag . " ";
      }
	  $taglist = substr($taglist, 0, -1); // trim the trailing space.
    }
  }

	$widget .="<input name=\"tagset\" value=\"";
	if ($post) {
		$widget .= stripslashes(str_replace('&', '&amp;', $utw->FormatTags($utw->GetTagsForPost($postid, $limit), array("first"=>'%tag%', 'default'=>', %tag%'))));
	}
	$widget .="\" style=\"width:98%\"><br />";

	$widgetToUse = get_option('utw_always_show_links_on_edit_screen');


	if ($widgetToUse != '不显示') {
		$widget .="添加存在的标签: ";
		if ($widgetToUse=='标签列表') {

			$format = "<a href=\"javascript:addTag('%tagjsescaped%')\">%tagdisplay%</a> ";
			$widget .= $utw->FormatTags($utw->GetPopularTags(-1, 'tag', 'asc'), $format);

		} else {
			$format = array(
			'pre' => '<select onchange="if (document.getElementById(\'tag-menu\').value != \'\') { addTag(document.getElementById(\'tag-menu\').value) }" id="tag-menu"><option selected="selected" value="">选择一个标签</option>',
			'default' => '<option value="%tag%">%tagdisplay% (%tagcount%)</option>',
			'post' => '</select>');

			$widget .= $utw->FormatTags($utw->GetPopularTags(-1, 'tag', 'asc'), $format);
		}
	}
  $suggestions .='<input type="button" onClick="askYahooForKeywords()" value="从 Yahoo 获取关键词建议"/>';
  $suggestions .='<div id="yahooSuggestedTags"></div>';

  echo '<fieldset id="tagsdiv" class="dbx-box">' . '<h3 class="dbx-handle">标签 (用半角逗号分隔)</h3><div class="dbx-content">' . $widget . '</div></fieldset>';
  echo '<fieldset id="tagsdiv" class="dbx-box">' . '<h3 class="dbx-handle">标签建议 (感谢 <a href="http://www.yahoo.com">Yahoo!</a>)</h3><div class="dbx-content">' . $suggestions . '</div></fieldset>';


}

function regExEscape($str) {
	$str = str_replace('\\', '\\\\', $str);
	$str = str_replace('/', '\\/', $str);
	$str = str_replace('[', '\\[', $str);
	$str = str_replace(']', '\\]', $str);

	return $str;
}

function replaceTagWithLink($matches) {
	global $utw, $embeddedtagformat;

	$tags = explode(',',$matches[2]);

	$tagstr = '';
	$first = true;
	foreach ($tags as $tag) {
		if ($first === false) {
			$tagstr .= ',';
		} else {
			$first = false;
		}
		$tagstr .= "'" . str_replace(' ','-',strtolower(trim($tag))) . "'";
	}

	$tag = $utw->GetTagsForTagString($tagstr);

	return $utw->FormatTags($tag, $embeddedtagformat);
}

function ultimate_the_content_filter($thecontent='') {
	global $post, $utw, $lzndomainvar, $starttag, $endtag, $starttags, $endtags, $embedtags;

	$tagStartMarker = $starttag;
	$tagEndMarker = $endtag;

	$tags = $utw->GetTagsForPost($post->ID);

	$findTagRegEx = '/(' . UltimateTagWarriorActions::regExEscape($starttag) . '(.*?)' . UltimateTagWarriorActions::regExEscape($endtag) . ')/i';
	$findTagsRegEx = '/(' . UltimateTagWarriorActions::regExEscape($starttags) . '(.*?)' . UltimateTagWarriorActions::regExEscape($endtags) . ')/i';

	if ($embedtags == 'yes') {
		$thecontent = preg_replace($findTagsRegEx, '', $thecontent);
		$thecontent = preg_replace_callback($findTagRegEx, array("UltimateTagWarriorActions","replaceTagWithLink"), $thecontent);
	}

	if (get_option('utw_include_local_links') != '不显示' ) {
		if (get_option('utw_primary_automagically_included_link_format') != '') {
			$custom = array();
			if (get_option('utw_primary_automagically_included_prefix') != '') {
				$custom['pre'] = stripslashes(get_option('utw_primary_automagically_included_prefix'));
			}
			if (get_option('utw_primary_automagically_included_suffix') != '') {
				$custom['post'] = stripslashes(get_option('utw_primary_automagically_included_suffix'));
			}

			$format = $utw->GetFormat(get_option('utw_primary_automagically_included_link_format'), $custom);
			$tagHTML = $utw->FormatTags($tags, $format);

			if (get_option('utw_include_local_links') == '在文章内容之前') {
				$thecontent = $tagHTML . $thecontent;
			} else {
				$thecontent = $thecontent . $tagHTML;
			}

		} else {
			// This is a throwback to when the format wasn't specified.
	//		$thecontent = $thecontent . $utw->FormatTags($tags, array("first"=>"<span class=\"localtags\">%taglink% ","default"=>"%taglink% ", "last"=>"%taglink%</span>"));
		}
	}

	if (get_option('utw_include_technorati_links') != '不显示') {
		if (get_option('utw_secondary_automagically_included_link_format') != '') {
			$custom = array();
			if (get_option('utw_secondary_automagically_included_prefix') != '') {
				$custom['pre'] = stripslashes(get_option('utw_secondary_automagically_included_prefix'));
			}
			if (get_option('utw_secondary_automagically_included_suffix') != '') {
				$custom['post'] = stripslashes(get_option('utw_secondary_automagically_included_suffix'));
			}

			$format = $utw->GetFormat(get_option('utw_secondary_automagically_included_link_format'), $custom);
			$tagHTML = $utw->FormatTags($tags, $format);

			if (get_option('utw_include_technorati_links') == '在文章内容之前') {
				$thecontent = $tagHTML . $thecontent;
			} else {
				$thecontent = $thecontent . $tagHTML;
			}
		} else {
			// This is a throwback to when the format wasn't specified.
	//		$thecontent = $thecontent . $utw->FormatTags($tags, array("pre"=>__("<span class=\"technoratitags\">Technorati Tags", $lzndomain) . ": ","default"=>"%technoratitag% ", "last"=>"%technoratitag%","none"=>"","post"=>"</span>"));
		}
	}


	if (is_feed() && get_option('utw_append_tag_links_to_feed')) {
		$thecontent = $thecontent . $utw->FormatTags($tags, $utw->GetFormatForType('commalist'));
	}

	// Don't include anything on 'page' posts if there are no tags.  There's a check for no tags in case people have tinkered with the page editing thing to allow it.
	if (count($tags) == 0 && $post->post_status == 'static') {
		return $thecontent;
	}

	return $thecontent;
}

function ultimate_add_tags_to_rss($the_list, $type="") {
	global $post, $utw;

    $categories = get_the_category();
    $the_list = '';
    foreach ($categories as $category) {
        $category->cat_name = convert_chars($category->cat_name);
        $the_list .= "\n\t<dc:subject>" . $category->cat_name . "</dc:subject>";
    }

	$format="<dc:subject>%tagdisplay%</dc:subject>";
	echo $the_list;
	$tags = $utw->FormatTags($utw->GetTagsForPost($post->ID), $format);
	echo str_replace('&', '&amp;', $tags);
}

function ultimate_add_ajax_javascript() {
	global $install_directory, $wp_query, $utw;

	if (get_query_var('tag') != "") {
		$wp_query->is_home = false;
	}

	echo "<script src=\"" . $utw->GetAjaxJavascriptUrl() . "\" type=\"text/javascript\"></script>";

}

function ultimate_add_admin_javascript() {
	global $install_directory;
	
	$js = get_option('siteurl') . "/wp-content/plugins$install_directory/ultimate-tag-warrior-js.php";
	echo "<script src=\"$js\" type=\"text/javascript\"></script>";
}

function ultimate_add_meta_keywords() {
	if (get_option('utw_show_meta_keywords') == 'yes') {
		UTW_ShowMetaKeywords();
	}
}

function ultimate_posts_join($join) {
	if (get_query_var("tag") != "") {
		global $table_prefix, $wpdb;

		$tabletags = $table_prefix . "tags";
		$tablepost2tag = $table_prefix . "post2tag";

		$join .= " INNER JOIN $tablepost2tag p2t on $wpdb->posts.ID = p2t.post_id INNER JOIN $tabletags t on p2t.tag_id = t.tag_id ";
	}
	return $join;
}

function ultimate_posts_where($where) {
	global $utw;
	if (get_query_var("tag") != "") {
		global $table_prefix, $wpdb;

		global $wp_query;

		$wp_query->is_home=false;

		$tabletags = $table_prefix . "tags";
		$tablepost2tag = $table_prefix . "post2tag";

		$tags = get_query_var("tag");

		$tagset = explode(" ", $tags);

		if (count($tagset) == 1) {
			$tagset = explode("|", $tags);
		}

		$tags = array();
		foreach($tagset as $tag) {
			$tags[] = "'" . $utw->GetCanonicalTag(str_replace("'",'',str_replace('"','',stripslashes($tag)))) . "'";
		}
		$tags = array_unique($tags);

		$taglist = implode (',',$tags);
		$where .= " AND t.tag IN ($taglist) ";
	}
	return $where;
}

function ultimate_query_vars($vars) {
	$vars[] = 'tag';

	return $vars;
}

/* Maaaaaybe some day...

function ultimate_posts_having () {
	if (get_query_var("tag") != "") {
		$tags = get_query_var("tag");
		$tagset = explode(" ", $tags);
		$taglist = "'" . $tagset[0] . "'";
		$tagcount = count($tagset);

		return " HAVING count(wp_posts.id) = $tagcount ";
	}
}
*/

}

// Admin menu items
add_action('admin_menu', array('UltimateTagWarriorActions', 'ultimate_admin_menus'));

// Add or edit tags
add_action('simple_edit_form', array('UltimateTagWarriorActions','ultimate_display_tag_widget'));
add_action('edit_form_advanced', array('UltimateTagWarriorActions','ultimate_display_tag_widget'));

// Save changes to tags
add_action('publish_post', array('UltimateTagWarriorActions','ultimate_save_tags'));
add_action('edit_post', array('UltimateTagWarriorActions','ultimate_save_tags'));
add_action('save_post', array('UltimateTagWarriorActions','ultimate_save_tags'));
add_action('wp_insert_post', array('UltimateTagWarriorActions','ultimate_save_tags'));

add_action('delete_post', array('UltimateTagWarriorActions', 'ultimate_delete_post'));

// Display tag pages
add_action('template_redirect', array('UltimateTagWarriorActions','ultimate_tag_templates'));

add_filter('posts_join', array('UltimateTagWarriorActions','ultimate_posts_join'));
add_filter('posts_where', array('UltimateTagWarriorActions','ultimate_posts_where'));
// add_filter('posts_having',array('UltimateTagWarriorActions','ultimate_posts_having'));

// URL rewriting
add_filter('rewrite_rules_array', array('UltimateTagWarriorActions','ultimate_rewrite_rules'));
add_filter('query_vars', array('UltimateTagWarriorActions','ultimate_query_vars'));

add_filter('the_content', array('UltimateTagWarriorActions', 'ultimate_the_content_filter'));
add_filter('the_category_rss', array('UltimateTagWarriorActions', 'ultimate_add_tags_to_rss'));

add_filter('wp_head', array('UltimateTagWarriorActions', 'ultimate_add_meta_keywords'));
add_filter('admin_head', array('UltimateTagWarriorActions', 'ultimate_add_admin_javascript'));
add_filter('admin_head', array('UltimateTagWarriorActions', 'ultimate_add_ajax_javascript'));
?>